# Parallelisation and Gridding
Although not included in the `networkcontagion` library, it is possible to both parallelise model runs (over the same set of parameters) and grid over sets of parameters. Both of these methods were employed by the CMA team when using the `networkcontagion` library to provide modelling advice to the New Zealand government. Although some of our methods are specific to the high-performance computing architecture that we used, we still outline them here (as well as explain how they could be implemented in a more general manner).

## Paralellisation
With a large and complex model such as this, which employs stochastic simulation methods, running the model on the same set of input parameters will produce a (possibly large) range of simulation results. It is therefore important to run the model multiple times on the same set of parameters to obtain a range of possible forecasts for each parameter configuration. The CMA team primarily used the model on the New Zealand eSscience Infrastructue (NeSI) High Performance Computing (HPC) platform (see [here](https://www.nesi.org.nz/services/high-performance-computing-and-data-analytics) for more information). NeSI makes use of the [Slurm](https://slurm.schedmd.com/documentation.html) workload manager as a way of managing and running compute 'jobs'. Slurm allows for a 'job array' to be set-up that runs the same script in parallel across the nodes of the HPC cluster. In this way, the CMA team was able to run multiple simulations for each configuration in a parameter grid of configurations, all simultaneously. Although many individuals will not have access to a similar level of parallel-computing power, it is still possible to use multi-core processing (or some similar type of parallelisation) to run multiple instances of `run_simulation.py` on the same/different parameter yamls with different `npz` output paths at the same time (perhaps in a shell script or similar).

### Serialisation
We also note that, although a parameter for multiple runs exists in the run options section of the parameter yaml, this parameter is actually not currently supported by the `networkcontagion` library. Originally, it was used to run multiple instances of the model in serial (for every time that `run_simulation.py` was called). However, due to the addition of features in other sections of the codebase, it is now defunct. If serial computing is required (indeed this maybe a simpler method of obtaining multiple model realisations as opposed to parallel computing), a for loop in a shell script or a similar method could be used to provide this functionality.

## Gridding
Due to the uncertainty involved in epidemics modelling, it is important to consider a range of different possible scenarios, when forecasting (especially in relation to things such as new variants, policy changes, vaccination introductions, etc.). This corresponds to gridding over a range of different parameters values (for example over a range of different transmissibility values). The CMA team used a Python script that took in a default yaml (that contained the base values of parameters that should not be gridded over) and an experiment yaml (that contained the parameter values to grid over). The Python script also created a directory structure and slurm files for use on NeSI. It may be of use to create a similar script for the easy generation of configuration yamls corresponding to the grid of parameters to be tested and possibly create a directory structure for ease of use/readability. However, this automation is not necessary and a grid of parameters could be setup by creating and modifying the different configuration yamls manually.